/*
 * ConsoleEngCalculatorAboutBox.java
 */

package consoleengcalculator;

import engcalculator.variable.Variable;
import java.awt.Color;
import java.util.LinkedList;

public class ConsoleEngCalculatorDrawBox extends javax.swing.JFrame {
    private final static int COLOR_SET_BY_VAL = 13;

    public final static boolean isColorSetByVal (int index) {
        return index == 13;
    }
    public final static boolean isColorSetByTol (int index) {
        return index == 14;
    }

    public final static Color colorConverter (int index) {
        switch (index) {
            case 0:
                return Color.BLACK;
            case 1:
                return Color.BLUE;
            case 2:
                return Color.CYAN;
            case 3:
                return Color.DARK_GRAY;
            case 4:
                return Color.GRAY;
            case 5:
                return Color.GREEN;
            case 6:
                return Color.LIGHT_GRAY;
            case 7:
                return Color.MAGENTA;
            case 8:
                return Color.ORANGE;
            case 9:
                return Color.PINK;
            case 10:
                return Color.RED;
            case 11:
                return Color.WHITE;
            case 12:
                return Color.YELLOW;
            default:
                //it was selected variable color
                return Color.WHITE;
        }
    }

    private ConsoleEngCalculatorDrawOptions drawOptions;
    private LinkedList<Drawing> drawings;

    public ConsoleEngCalculatorDrawBox() {
        initComponents();
        getRootPane().setDefaultButton(jButtonCancel);
        drawings = new LinkedList<Drawing> ();
        
        drawOptions = new ConsoleEngCalculatorDrawOptions(this);
        drawOptions.storeDataOnCanvas();

    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel4 = new javax.swing.JPanel();
        jPanelCartesian = new consoleengcalculator.FunctionDrawerJPanel();
        jPanelDrawing = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jComboBoxDrawing = new javax.swing.JComboBox();
        jComboBoxColor = new javax.swing.JComboBox();
        jCheckBoxJoined = new javax.swing.JCheckBox();
        jPanelColor = new consoleengcalculator.GradientJPanel ();
        jCheckBoxVisible = new javax.swing.JCheckBox();
        jButtonRedraw = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jButtonOptions = new javax.swing.JButton();
        jButtonUp = new javax.swing.JButton();
        jButtonDown = new javax.swing.JButton();

        jPanel4.setName("jPanel4"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(consoleengcalculator.ConsoleEngCalculatorApp.class).getContext().getResourceMap(ConsoleEngCalculatorDrawBox.class);
        setTitle(resourceMap.getString("title")); // NOI18N
        setName("Variable Shower"); // NOI18N
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        jPanelCartesian.setBackground(resourceMap.getColor("jPanelCartesianPlane.background")); // NOI18N
        jPanelCartesian.setName("jPanelCartesianPlane"); // NOI18N

        javax.swing.GroupLayout jPanelCartesianLayout = new javax.swing.GroupLayout(jPanelCartesian);
        jPanelCartesian.setLayout(jPanelCartesianLayout);
        jPanelCartesianLayout.setHorizontalGroup(
            jPanelCartesianLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 991, Short.MAX_VALUE)
        );
        jPanelCartesianLayout.setVerticalGroup(
            jPanelCartesianLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 470, Short.MAX_VALUE)
        );

        jPanelDrawing.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanelDrawing.border.title"))); // NOI18N
        jPanelDrawing.setName("jPanelDrawing"); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jComboBoxDrawing.setName("jComboBoxDrawing"); // NOI18N
        jComboBoxDrawing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxDrawingActionPerformed(evt);
            }
        });

        jComboBoxColor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BLACK", "BLUE", "CYAN", "DARK_GRAY", "GRAY", "GREEN", "LIGHT_GRAY", "MAGENTA", "ORANGE", "PINK", "RED", "WHITE", "YELLOW", "Set by value", "Set by tolerance" }));
        jComboBoxColor.setName("jComboBoxColor"); // NOI18N
        jComboBoxColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxColorActionPerformed(evt);
            }
        });

        jCheckBoxJoined.setText(resourceMap.getString("jCheckBoxJoined.text")); // NOI18N
        jCheckBoxJoined.setName("jCheckBoxJoined"); // NOI18N
        jCheckBoxJoined.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxJoinedActionPerformed(evt);
            }
        });

        jPanelColor.setBackground(resourceMap.getColor("jPanelColor.background")); // NOI18N
        jPanelColor.setName("jPanelColor"); // NOI18N

        javax.swing.GroupLayout jPanelColorLayout = new javax.swing.GroupLayout(jPanelColor);
        jPanelColor.setLayout(jPanelColorLayout);
        jPanelColorLayout.setHorizontalGroup(
            jPanelColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 53, Short.MAX_VALUE)
        );
        jPanelColorLayout.setVerticalGroup(
            jPanelColorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 27, Short.MAX_VALUE)
        );

        jCheckBoxVisible.setText(resourceMap.getString("jCheckBoxVisible.text")); // NOI18N
        jCheckBoxVisible.setName("jCheckBoxVisible"); // NOI18N
        jCheckBoxVisible.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxVisibleActionPerformed(evt);
            }
        });

        jButtonRedraw.setText(resourceMap.getString("jButtonRedraw.text")); // NOI18N
        jButtonRedraw.setName("jButtonRedraw"); // NOI18N
        jButtonRedraw.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRedrawActionPerformed(evt);
            }
        });

        jButtonCancel.setText(resourceMap.getString("jButtonCancel.text")); // NOI18N
        jButtonCancel.setName("jButtonCancel"); // NOI18N
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jButtonOptions.setText(resourceMap.getString("jButtonOptions.text")); // NOI18N
        jButtonOptions.setName("jButtonOptions"); // NOI18N
        jButtonOptions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOptionsActionPerformed(evt);
            }
        });

        jButtonUp.setText(resourceMap.getString("jButtonUp.text")); // NOI18N
        jButtonUp.setName("jButtonUp"); // NOI18N
        jButtonUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUpActionPerformed(evt);
            }
        });

        jButtonDown.setText(resourceMap.getString("jButtonDown.text")); // NOI18N
        jButtonDown.setName("jButtonDown"); // NOI18N
        jButtonDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDownActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelDrawingLayout = new javax.swing.GroupLayout(jPanelDrawing);
        jPanelDrawing.setLayout(jPanelDrawingLayout);
        jPanelDrawingLayout.setHorizontalGroup(
            jPanelDrawingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelDrawingLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButtonUp)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonDown)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jComboBoxDrawing, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jComboBoxColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBoxVisible)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBoxJoined)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 27, Short.MAX_VALUE)
                .addComponent(jButtonOptions)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonRedraw)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonCancel)
                .addContainerGap())
        );
        jPanelDrawingLayout.setVerticalGroup(
            jPanelDrawingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelDrawingLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanelDrawingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonUp)
                    .addComponent(jButtonDown)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBoxDrawing, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBoxColor, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBoxVisible)
                    .addComponent(jCheckBoxJoined)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonRedraw)
                    .addComponent(jButtonOptions))
                .addContainerGap())
            .addGroup(jPanelDrawingLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelColor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanelDrawingLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jButtonCancel, jButtonOptions, jButtonRedraw, jComboBoxColor, jComboBoxDrawing, jLabel3, jLabel5, jPanelColor});

        jPanelDrawingLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jCheckBoxJoined, jCheckBoxVisible});

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanelCartesian, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanelDrawing, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelCartesian, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanelDrawing, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    private void jComboBoxColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxColorActionPerformed
        int color = jComboBoxColor.getSelectedIndex();
        jPanelColor.setBackground(colorConverter(color));
        if (isColorSetByTol(color) || isColorSetByVal(color)) ((GradientJPanel) jPanelColor).setShowGradient(true);
        else ((GradientJPanel) jPanelColor).setShowGradient(false);
        Drawing d = ((Drawing) jComboBoxDrawing.getSelectedItem());
        if (d != null) d.setColorIndex(color);
    }//GEN-LAST:event_jComboBoxColorActionPerformed

    private void jComboBoxDrawingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxDrawingActionPerformed
        if (jComboBoxDrawing.getSelectedIndex() == -1) return;
        Drawing d = (Drawing) jComboBoxDrawing.getSelectedItem();
        if (d != null) {
            jComboBoxColor.setSelectedIndex(d.getColorIndex());
            jCheckBoxJoined.setSelected(d.isJoined());
            jCheckBoxVisible.setSelected(d.isVisible());
        }
}//GEN-LAST:event_jComboBoxDrawingActionPerformed

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        setupDrawings();
        if (jComboBoxDrawing.getItemCount() > 0) {
            jComboBoxDrawing.setSelectedIndex(0);
            jComboBoxDrawingActionPerformed(null);
        }
    }//GEN-LAST:event_formWindowActivated

    private void jButtonRedrawActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRedrawActionPerformed
       ((FunctionDrawerJPanel) jPanelCartesian).setDrawings(drawings);
        jPanelCartesian.repaint();
    }//GEN-LAST:event_jButtonRedrawActionPerformed
    
    private void jButtonOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOptionsActionPerformed
        drawOptions.setVisible(true);
    }//GEN-LAST:event_jButtonOptionsActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        setVisible(false);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jCheckBoxVisibleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxVisibleActionPerformed
        Drawing d = ((Drawing) jComboBoxDrawing.getSelectedItem());
        if (d != null) d.setVisible(jCheckBoxVisible.isSelected());
    }//GEN-LAST:event_jCheckBoxVisibleActionPerformed

    private void jCheckBoxJoinedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxJoinedActionPerformed
        Drawing d = ((Drawing) jComboBoxDrawing.getSelectedItem());
        if (d != null) d.setJoined(jCheckBoxJoined.isSelected());
    }//GEN-LAST:event_jCheckBoxJoinedActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        jPanelCartesian.repaint();
    }//GEN-LAST:event_formWindowGainedFocus

    private void jButtonUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpActionPerformed
        int i = jComboBoxDrawing.getSelectedIndex();
        while (--i >= 0)
            if (((Drawing) jComboBoxDrawing.getItemAt(i)).isVisible()) break;
        if (i >= 0) jComboBoxDrawing.setSelectedIndex(i);
    }//GEN-LAST:event_jButtonUpActionPerformed

    private void jButtonDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDownActionPerformed
        int i = jComboBoxDrawing.getSelectedIndex();
        while (++i < jComboBoxDrawing.getItemCount())
            if (((Drawing) jComboBoxDrawing.getItemAt(i)).isVisible()) break;
        if (i < jComboBoxDrawing.getItemCount()) jComboBoxDrawing.setSelectedIndex(i);
    }//GEN-LAST:event_jButtonDownActionPerformed

    public FunctionDrawerJPanel getFunctionDrawer () {
        return (FunctionDrawerJPanel) jPanelCartesian;
    }

    public LinkedList<Drawing> getDrawings() {
        return drawings;
    }
    
    private void setupDrawings () {
        boolean exists;
        String v;
        Drawing dra;       

        //adds new variables
        for (Variable var : Variable.getVariables()) {
            int col;
            col = var.getValue().getColumns() ;
            if (! var.getValue().isMatrix() || col < 2 || col > 3) continue;
            
            exists = false;
            v = var.getSymbol();
            for (Drawing d : drawings) 
                if (v.equals(d.getName())) {
                    exists = true;
                    break;
                }

            dra = new Drawing (v, false, false, col == 2 ? 0 : COLOR_SET_BY_VAL);
            if (! exists) {
                jComboBoxDrawing.addItem(dra);
                drawings.add(dra);
            }
        }

        //removes deleted variables
        for (int i=0;i<drawings.size(); ++i) {
            dra = drawings.get(i);
            exists = false;
            v = dra.getName();
            for (Variable var : Variable.getVariables())
                if (v.equals(var.getSymbol())) {
                    exists = true;
                    break;
                }

            if (! exists) {
                jComboBoxDrawing.removeItemAt(i);
                drawings.remove(i);
                --i;
            }
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonDown;
    private javax.swing.JButton jButtonOptions;
    private javax.swing.JButton jButtonRedraw;
    private javax.swing.JButton jButtonUp;
    private javax.swing.JCheckBox jCheckBoxJoined;
    private javax.swing.JCheckBox jCheckBoxVisible;
    private javax.swing.JComboBox jComboBoxColor;
    private javax.swing.JComboBox jComboBoxDrawing;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanelCartesian;
    private javax.swing.JPanel jPanelColor;
    private javax.swing.JPanel jPanelDrawing;
    // End of variables declaration//GEN-END:variables
    
}
