/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.data.IntervalList;
import engcalculator.function.infix.InfixFunction;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public abstract class Token { //just a container for all types of components findable
    protected static final boolean DEBUG = false;
    private static boolean definingFunction;

    public static boolean isDefiningFunction() {
        return definingFunction;
    }

    public static void setDefiningFunction(boolean definingFunction) {
        Token.definingFunction = definingFunction;
    }

    private String symbol;

    public Token () {}

    public Token (String symbol) {
        this.symbol = symbol;
    }

    public String getSymbol() {
        return symbol;
    }

    public boolean isSignificant () {
        return true;
    }

    public boolean isVariable () {
        return false;
    }

    abstract public Token generateToken (String symbol);

    abstract public boolean mayBeCompatible ( String symbol);

    public Token regenerateToken () {
        return this;
    }

    public IntervalList getIntervalList () throws Exception {
        return null;
    }

    public InfixFunction getInfixFunction () {
        return null;
    }

    public PrefixFunction getPrefixFunction () {
        return null;
    }

    public String getTerminal () {
        return null;
    }

    @Override
    public String toString () {
        if (DEBUG) return "<"+this.getClass().getSimpleName()+" "+symbol+"> ";
        return symbol;

    }

}
