/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix;

import engcalculator.data.Interval;
import engcalculator.function.CalculusException;
import java.util.Arrays;
import java.util.Vector;

/**
 *
 * @author simone
 */
public class Pow extends DualInputSingleOutputInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"-1_2","-1_2", "1_2", "1_2"};
    private final static String[] EXAMPLE_RIGHT = {"2","3", "2", "3"};
    private final static String[] RESULT = {"0_4","-1_8","1_4","1_8"};

    public Pow() {
        super ("^", true, true, "a ^ b Power a to b potence.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval _computeIntervals(Interval a, Interval b) throws Exception {
        if (b.isEven()) {
            double power = b.getLeft();
            if(a.isPositive()) return new Interval(Math.pow(a.getLeft(), power), Math.pow(a.getRight(), power)).setOuter();
            if(a.isNegative()) return new Interval(Math.pow(a.getRight(), power), Math.pow(a.getLeft(), power)).setOuter();
            if(a.isProper()) return new Interval(0, Math.max(Math.pow(a.getLeft(), power), Math.pow(a.getRight(), power))).setOuter();
            return new Interval(Math.max(Math.pow(a.getLeft(), power), Math.pow(a.getRight(), power)), 0).setOuter();
        } else {
            double[] values = new double[4];
            values[0] = Math.pow(a.getLeft(), b.getLeft());
            values[1] = Math.pow(a.getLeft(), b.getRight());
            values[2] = Math.pow(a.getRight(), b.getLeft());
            values[3] = Math.pow(a.getRight(), b.getRight());
            Arrays.sort(values);
            if (a.isProper() && ! b.isProper()) return new Interval(values[3], values[0]);
            if (! a.isProper() && ! b.isProper()) return new Interval(values[3], values[0]);
            return new Interval(values[0], values[3]);
        }
    }
}
