/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.matrix;

import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.InfixFunction;

/**
 *
 * @author simone
 */
public class MatrixBuilder extends InfixFunction {
    private final static String[] EXAMPLE_LEFT = {"5,6,7,8","5,6,7,8","5,6,7,8"};
    private final static String[] EXAMPLE_RIGHT = {"2","2_0","0_2"};
    private final static String[] RESULT = {"(5,6,7,8)#2","(5,6,7,8)#(2_0)","(5,6,7,8)#(0_2)"};

    public MatrixBuilder() {
        super ("#", (byte) -1, (byte) 1, false, true, "Given a list and the number of columns of the matrix it builds up a matrix.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList left, IntervalList right) throws Exception {
        if (right.getFirst().isScalar() || right.getFirst().getRight() == 0) {
            if (left.size() % right.getFirst().getLeft() != 0) throw new CalculusException ("The number of columns of the matrix must be an integer multiple of the number of elements of the list");
            return new MatrixIntervalList(left, (int) right.getFirst().getLeft());
        } else if (right.getFirst().getLeft() == 0) {
            if (left.size() % right.getFirst().getRight() != 0) throw new CalculusException ("The number of columns of the matrix must be an integer multiple of the number of elements of the list");
            return new MatrixIntervalList(left, (int) (left.size() / right.getFirst().getRight() ));
        } else throw new CalculusException ("The matrix builder argument is not proper.");
    }
}
