/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.engineering;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.interval.IntervalByToleranceBuilder;

/**
 *
 * @author simone
 */
public class FromColorCode extends PrefixFunction {
    private final static String[] RESULTS = {"100K%10", "33%5"};
    private final static String[] EXAMPLES = {"brown, black, yellow, silver","orange, orange, black, gold"};

    private final static String[] COLORS = {"black", "brown", "red", "orange", "yellow", "green", "blue", "violet", "gray", "white", "gold", "silver", "none"};
    private final static float[] TOLERANCE = {-1, 1, 2, -1, -1, 0.5f, 0.25f, 0.1f, 0.05f, -1, 5, 10, 20};

    private final static IntervalByToleranceBuilder INTERVAL_BY_TOLERANCE_BUILDER = new IntervalByToleranceBuilder();

    public FromColorCode() {
        super ("fromcolor", (byte) -1, true, true, "Convert the given color code to a numeric value.", EXAMPLES, RESULTS);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        double val=0, tol=0;
        final int s = input.size()-2;
        int i;
        for (i=0;i<s;++i)
            val = val*10+findCloserIndex(COLORS, input.get(i).getName(),false);

        val *= Math.pow(10, findCloserIndex(COLORS, input.get(i).getName(), false));

        tol = TOLERANCE[findCloserIndex(COLORS, input.get(++i).getName(), false)];
        
        return new IntervalList( INTERVAL_BY_TOLERANCE_BUILDER._computeIntervals(new Interval(val), new Interval (tol)));

    }

}
