/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.information;

import engcalculator.function.Function;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.Literal;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;
import java.util.Collection;

/**
 *
 * @author simone
 */
public class Help extends PrefixFunction {
    
    public Help () {
        super ("help", (byte) -1, false,true, "help provides the help of all the functions staring with the literal provided in its list. Without arguments, it provides the help of all the functions. Ex.: help 'sin'", null, null);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {

        for (Interval i: input)
            if (i.getName() == null) throw new CalculusException( "It is expected a list of literals to look for help.");

        IntervalList help = new IntervalList ();
        String fhelp;

       Collection<Function> functions = Function.getFunctions();
       for (Function f : functions) {
           if (input.size() == 0) {
               fhelp = f.getHelp();
               if (!fhelp.equals("")) help.add(new Literal(fhelp));
           }
           else {
               for (Interval in : input) {
                   if (f.getSymbol().startsWith(in.getName())) {
                        fhelp = f.getHelp();
                        if (!fhelp.equals("")) help.add(new Literal(fhelp));
                   }
               }
           }
       }

        return new IntervalList ( new Literal(help.toString()));
    }

}
