/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Direction extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_10","10_-5", "10_10"};
    private final static String[] RESULT = {"1", "-1", "1"};

    public Direction() {
        super("direction", true, true, "direction returns -1, if A is an improper directed interval; 1, if A is proper or degenerate and 0, if A involves NaN.", EXAMPLE , RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval input) throws Exception {
        double a1 = input.getLeft(), a2 = input.getRight();
        if (Double.isNaN(a1) || Double.isNaN(a2)) return new Interval(0);
        if (a1 <= a2) return new Interval(1);
        return new Interval(-1);
    }
}
