/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.plot;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.list.ListBuilder;

/**
 *
 * @author simone
 */
public class SurfacePlot extends PrefixFunction {
    private final static String[] EXAMPLE = {"sp=surfaceplot(('f',x,y)='x+y', 2, 2_4, 2, 2_4);sp"};
    private final static String[] RESULT = {"((1_3,1_3,3_5,3_5)#1 ,| (1_3,3_5,1_3,3_5)#1 ,| (2_6,4_8,4_8,6_10)#1)"};
    private final static ListBuilder LIST_BUILDER = new ListBuilder();

    public SurfacePlot () {
        super("surfaceplot", (byte) 5, false, false, "surfaceplot builds an array which can later be used to plot the hight of a function with a color graph. It requires the function name to compute its height (z), the number of squares on x, the range of x, the number of square on y, the range of y.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        String fname = input.getFirst().getName();
        if (fname == null) throw new CalculusException ("It is expected a function name as first element");
        PrefixFunction f = PrefixFunction.getFunction(fname);
        if (f == null) throw new CalculusException ("It is not possible to find a function matching the given name");
        if (f.getNumbArgs() != 2) throw new CalculusException ("It is required a function of 2 arguments");

        double xmin = input.get(2).getLeft();
        double xmax = input.get(2).getRight();
        final double xdelta = (xmax-xmin)/2/(input.get(1).getVal()-1);

        double ymin = input.get(4).getLeft();
        double ymax = input.get(4).getRight();
        final double ydelta = (ymax-ymin)/2/(input.get(3).getVal()-1);

        IntervalList ytmpil = new IntervalList ();
        for (double yval=ymin; yval <= ymax; yval += ydelta + ydelta) {
            ytmpil.append(new Interval (yval-ydelta,yval+ydelta));
        }

        MatrixIntervalList x = new MatrixIntervalList (1);
        MatrixIntervalList y = new MatrixIntervalList (1);
        Interval xtmp;
        for (double xval=xmin; xval <= xmax; xval += xdelta + xdelta) {
            xtmp = new Interval (xval-xdelta,xval+xdelta);
            for (Interval ytmp: ytmpil) {
                y.append(ytmp);
                x.append(xtmp);
            }
        }

        //it is not used the property of function to work on list in order to skip the 'bad' values
        MatrixIntervalList result = new MatrixIntervalList (3);
        IntervalList data = new IntervalList ();
        final int s = x.size();
        for (int i=0; i<s; ++i) {
            Interval z;
            data.clear();
            data.add(x.get(i));
            data.add(y.get(i));
            try {               
                z = f._compute(data).getFirst();
                result.addAll(data);
                result.add(z);
            } catch (Exception ce) {
            }
        }

        return result;
    }

}
