/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.trigonometry;

import engcalculator.function.CalculusException;
import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public abstract class ArcTrig extends SingleInputSingleOutputPrefixFunction {
    private double min, max;
    private boolean increasing;
//    private final static Proper PROPER = new Proper();

    public ArcTrig(String name, double min, double max,boolean increasing, String help, String[] examples, String[] results) {
        super (name, true, true, help, examples, results);
        this.min = min;
        this.max = max;
        this.increasing = increasing;
    }

    @Override
    public final Interval _computeIntervals (Interval a) throws Exception {
        if (a.getLeft() < min || a.getRight() > max) throw new CalculusException("The interval is out of range for "+getSymbol()+": ("+min+","+max+")");

        if (increasing) return new Interval (__compute(a.getLeft()), __compute(a.getRight()));
        return new Interval (__compute(a.getRight()), __compute(a.getLeft()));
    }

    protected abstract double __compute (double input) ;

}
